package oop.ExceptionHandling;

public class Finally {

	public static void main(String[] args) {
		/*
		 * Wenn ein Programmfehler auftaucht, springe in catch Block gib den Fehler aus und laufe nicht weiter
		 * und am Ende gib finally Block aus!
		 */
		try {
			int arr[] = new int[5];
			arr[7] = 5;
			
		}catch(Exception e) {
			
			System.out.println(e);
			return;
		
		}finally {
			System.out.println("finally");
		}
		
		
		/*
		 * wegen System.exit in catch wird finally Block nicht ausgegenen
		 */
		try {
			int arr[] = new int[5];
			arr[7] = 5;
			
		}catch(Exception e) {
			
			System.out.println(e);
			System.exit(0);
		
		}finally {
			System.out.println("finally");
		}
		//System.out.println(getNumber(3));
		
		
	}
	
	// hier wir die 3 ausgegben, weil finally soll ausgegeben werden
	public static int getNumber(int x) {
		
		try {
			if (x == 3)
				return 1;
			
		}catch (Exception e){
			return 2;
			
		}finally {
			System.out.println("tu etwas");
		}
		return x;
	}
}
